.ifndef	USB_Inc
.define USB_Inc

.public _USB_Status_HID
.public _R_USB_State_Machine_HID

.public	USB_RW_Buffer
.public	_USB_Status
.public _Bulk_Stall
.public _R_USB_Suspend
.public _R_USB_State_Machine
.public _R_EP0DataCount
.public R_Descriptor_High
.public R_Descriptor_Low
.public _R_Descriptor_High
.public _R_Descriptor_Low
.public _CSW_Status
.public _Sense_Code
.public _ulTimeout
.public _MaxLUN
.public _Max_LUN
.public	_HIDProtocol
.public	_HID_Protocol
.public _CDROMEnable
.public _CDROMDelay
.public _R_USB_RW_Busy
.public _USBD_PlugIn
.public _gEP0InOutFlag
.public _data_send_flag
.public _INT_IN_BUFFER
.public _INT_IN_BUFFER_Read

.public _Mouse_BYTE1
.public _Mouse_BYTE2
.public _Mouse_BYTE3
.public _Mouse_BYTE4

///////////////////////////////////ASM Export Table///////////////////////////////////////////
.external 	_SCSISENSE
.external	_Device_Descriptor
.external	_Config_Descriptor
.external	_String0_Descriptor
.external	_String1_Descriptor
.external	_String2_Descriptor
.external	_String3_Descriptor
.external	_String4_Descriptor
.external	_DeviceVersionInfo
.external   _MouseReportDescriptor
.external	_HID_Descriptor

.external   _SCSIInquiryData
.external   _SCSIInquiryData_End
.external   _SCSIInquiryData_CDROM
.external   _SCSIInquiryData_CDROM_End
.external   _SCSIInquiryData_CardReader
.external   _SCSIInquiryData_CardReader_End
.external   _ScsiModeSense10CDROM
.external   _ScsiModeSense10CDROM_End
.external  _Nand_Part0_Size
.external  _Nand_Part1_Size
.external  _Nand_Part2_Size

///////////////////////////////////ASM Export Function///////////////////////////////////////////
.external _CheckCDRomValid

////////////////////////////////Global Valuable/////////////////////////////////////////////////////
USB_RAM_Section:	.section	.ORAM //,.addr=0x800//.addr=0x6C00
USB_RW_Buffer:
	.dw		512		dup(?)

_CSW_Residue:		.dw	2 dup(?)	
_NandIDBuffer:		.dw 3 dup(?)
_R_CBW_PKT:			.dw 31 dup(?)
_NandTotalSector:	.dw	2 dup(?)	
_unGotoRamStart:	.dw 1 dup(?)
_ulTimeout: 		.dw 2 dup(?)
_USBLunStatus: 		.dw 5 dup(?)	//lun status, Okay or MediaChange
_ptr_USB_LUN_Info:	.dw 2 dup(?)
_INT_IN_BUFFER:		.dw 8 dup(?)
_INT_IN_BUFFER_Read:		.dw 8 dup(?)
_Mouse_BYTE1:		.dw 1 dup(?)
_Mouse_BYTE2:		.dw 1 dup(?)
_Mouse_BYTE3:		.dw 1 dup(?)
_Mouse_BYTE4:		.dw 1 dup(?)
////////////////////////
	.var    _USB_Status_HID
	.var	_R_USB_State_Machine_HID
	
	.var	_USB_Status
	.var	_Bulk_Stall
	.var	_R_USB_Suspend
	.var	_R_USB_State_Machine
	.var	_R_USB_RW_Busy			//If device is read/write, this flag will be set 1. Otherwise set 0.
	.var	_R_EP0DataCount
	.var	_CSW_Status
	.var	_Sense_Code	
	.var	R_Descriptor_High
_R_Descriptor_High:	.equ R_Descriptor_High		
	.var	R_Descriptor_Low
_R_Descriptor_Low:	.equ R_Descriptor_Low		
	.var	_USBWriteProtect
	.var	_CDROMEnable
	.var 	_CDROMDelay
	.var	_USBD_PlugIn			//0:Device not connect to PC, 1:Device connect to PC
	.var   _gEP0InOutFlag
	.var   _data_send_flag
_Max_LUN:
	.var	_MaxLUN					//Lun number, 0=1 lun, 1=2 luns.
_HID_Protocol:
	.var	_HIDProtocol


.endif	
/////////////////////////